<?php

namespace STM\Club;

use \Exception;
use STM\StmFactory;

/**
 * Test class for Club.
 * Generated by PHPUnit on 2012-02-14 at 14:15:58.
 * @group team_club
 */
class ClubTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Club) */
    private $all_clubs;

    protected function setUp() {
        $this->all_clubs = StmFactory::find()->Club->findAll();
    }

    public function testfindById() {
        foreach ($this->all_clubs as $club) {            
            parent::assertInstanceOf('\STM\Club\Club', StmFactory::find()->Club->findById($club->getId()));
        }
        // argument must be numeric
        parent::assertFalse(StmFactory::find()->Club->findById('nou camp'));
        parent::assertFalse(StmFactory::find()->Club->findById(null));
        parent::assertFalse(StmFactory::find()->Club->findById(new Exception()));
    }


    public function testFind_all() {
        parent::assertTrue(is_array($this->all_clubs));
        foreach ($this->all_clubs as $club) {            
            parent::assertInstanceOf('\STM\Club\Club', $club);
        }
    }

    public function testCreate() {
        parent::markTestSkipped('test in ClubValidatorTest');
    }

    public function testExists_club() {
        foreach ($this->all_clubs as $club) {            
            $name = $club->__toString();   
            // case-INsensitive
            parent::assertTrue(Club::exists($name));            
            parent::assertTrue(Club::exists(mb_strtolower($name, 'UTF-8')));
            parent::assertTrue(Club::exists(mb_strtoupper($name, 'UTF-8')));
            parent::assertFalse(Club::exists('_*A*_' . $name));
            // argumetn must be string
            parent::assertFalse(Club::exists($club));
            parent::assertFalse(Club::exists(null));
        }
    }

    public function testIs_team_from_club() {        
        foreach ($this->all_clubs as $club) {
            // argument must be string
            parent::assertFalse($club->isTeamFromClub(null));
            foreach (StmFactory::find()->Team->findByClub($club) as $team) {
                parent::assertFalse($club->isTeamFromClub($team));
                $team_name = $team->__toString();
                parent::assertTrue($club->isTeamFromClub($team_name));
                parent::assertTrue($club->isTeamFromClub(mb_strtolower($team_name, 'UTF-8')));
                parent::assertTrue($club->isTeamFromClub(mb_strtoupper($team_name, 'UTF-8')));
                parent::assertFalse($club->isTeamFromClub('_*A*_' . $team_name));
            }
        }
    }
    
    public function testDelete() {
        parent::markTestSkipped('in testCan_be_deleted, otherwise only DB fail');
    }

    public function testCan_be_deleted() {        
        foreach ($this->all_clubs as $club) {
            $teams = StmFactory::find()->Team->findByClub($club);            
            $members = StmFactory::find()->ClubMember->findByClub($club);
            $canBeDeleted = empty($teams) && empty($members);
            parent::assertTrue($club->canBeDeleted() == $canBeDeleted);
        }
    }

    public function testUpdate() {
        parent::markTestSkipped('test in ClubValidatorTest');
    }

    public function testGet_id() {
        $this->assert_get_to_function('is_int', 'getId');
    }

    public function testGet_id_country() {
        $this->assert_get_to_function('is_scalar', 'getIdCountry');
    }

    public function testGet_id_stadium() {
        $this->assert_get_to_function('is_scalar', 'getIdStadium');
    }

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }

    public function test__toString() {
        $this->assert_get_to_function('is_string', '__toString');
    }

    private function assert_get_to_function($function, $method_name) {
        foreach ($this->all_clubs as $club) {
            parent::assertTrue($function($club->$method_name()));
        }
    }
}

?>
